<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.15"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>My Project: TFTP Class Reference</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">My Project
   </div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.15 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
var searchBox = new SearchBox("searchBox", "search",false,'Search');
/* @license-end */
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
/* @license-end */</script>
<div id="main-nav"></div>
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

</div><!-- top -->
<div class="header">
  <div class="summary">
<a href="#nested-classes">Classes</a> &#124;
<a href="#pub-methods">Public Member Functions</a> &#124;
<a href="classTFTP-members.html">List of all members</a>  </div>
  <div class="headertitle">
<div class="title">TFTP Class Reference</div>  </div>
</div><!--header-->
<div class="contents">

<p>A TFTP server.  
 <a href="classTFTP.html#details">More...</a></p>

<p><code>#include &lt;<a class="el" href="TFTP_8h_source.html">TFTP.h</a>&gt;</code></p>
<table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="nested-classes"></a>
Classes</h2></td></tr>
<tr class="memitem:"><td class="memItemLeft" align="right" valign="top">class &#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classTFTP_1_1TFTP__Transaction.html">TFTP_Transaction</a></td></tr>
<tr class="memdesc:"><td class="mdescLeft">&#160;</td><td class="mdescRight">Internal class for TFTP processing.  <a href="classTFTP_1_1TFTP__Transaction.html#details">More...</a><br /></td></tr>
<tr class="separator:"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pub-methods"></a>
Public Member Functions</h2></td></tr>
<tr class="memitem:a8a8386ee01e4bad105cb1fee4e7aae51"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classTFTP.html#a8a8386ee01e4bad105cb1fee4e7aae51">start</a> (uint16_t port=TFTP_DEFAULT_PORT)</td></tr>
<tr class="memdesc:a8a8386ee01e4bad105cb1fee4e7aae51"><td class="mdescLeft">&#160;</td><td class="mdescRight">Start being a <a class="el" href="classTFTP.html" title="A TFTP server.">TFTP</a> server.  <a href="#a8a8386ee01e4bad105cb1fee4e7aae51">More...</a><br /></td></tr>
<tr class="separator:a8a8386ee01e4bad105cb1fee4e7aae51"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a13a7562a16fea3acabafc3c0811cabef"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classTFTP.html#a13a7562a16fea3acabafc3c0811cabef">setBaseDir</a> (std::string baseDir)</td></tr>
<tr class="memdesc:a13a7562a16fea3acabafc3c0811cabef"><td class="mdescLeft">&#160;</td><td class="mdescRight">Set the base dir for file access. If we are asked to put a file to the file system, this is the base relative directory.  <a href="#a13a7562a16fea3acabafc3c0811cabef">More...</a><br /></td></tr>
<tr class="separator:a13a7562a16fea3acabafc3c0811cabef"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table>
<a name="details" id="details"></a><h2 class="groupheader">Detailed Description</h2>
<div class="textblock"><p>A TFTP server. </p>
<p>The Trivial File Transfer Protocol is a specification for simple file transfer without the richness of implementation of full FTP. It is very easy to implement both a server and a client. The protocol leverages UDP as opposed to connection oriented (TCP). The specification can be found <a href="https://tools.ietf.org/html/rfc1350">here</a>.</p>
<p>Here is an example fragment which mounts a file system and then starts a TFTP server to provide access to its content.</p>
<div class="fragment"><div class="line"><a class="code" href="classFATFS__VFS.html">FATFS_VFS</a> fs(<span class="stringliteral">&quot;/spiflash&quot;</span>, <span class="stringliteral">&quot;storage&quot;</span>);</div><div class="line">fs.<a class="code" href="classFATFS__VFS.html#a1ba2a6e8e774a477513241ebad7d6607">mount</a>();</div><div class="line"></div><div class="line"><a class="code" href="classTFTP.html">TFTP</a> tftp;</div><div class="line">tftp.<a class="code" href="classTFTP.html#a13a7562a16fea3acabafc3c0811cabef">setBaseDir</a>(<span class="stringliteral">&quot;/spiflash&quot;</span>);</div><div class="line">tftp.<a class="code" href="classTFTP.html#a8a8386ee01e4bad105cb1fee4e7aae51">start</a>();</div></div><!-- fragment --><p>On Linux, I recommend the <a href="https://linux.die.net/man/1/atftp">atftp</a> client. </p>
</div><h2 class="groupheader">Member Function Documentation</h2>
<a id="a13a7562a16fea3acabafc3c0811cabef"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a13a7562a16fea3acabafc3c0811cabef">&#9670;&nbsp;</a></span>setBaseDir()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void TFTP::setBaseDir </td>
          <td>(</td>
          <td class="paramtype">std::string&#160;</td>
          <td class="paramname"><em>baseDir</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Set the base dir for file access. If we are asked to put a file to the file system, this is the base relative directory. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">baseDir</td><td>Base directory for file access. </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>N/A. </dd></dl>

</div>
</div>
<a id="a8a8386ee01e4bad105cb1fee4e7aae51"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a8a8386ee01e4bad105cb1fee4e7aae51">&#9670;&nbsp;</a></span>start()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void TFTP::start </td>
          <td>(</td>
          <td class="paramtype">uint16_t&#160;</td>
          <td class="paramname"><em>port</em> = <code>TFTP_DEFAULT_PORT</code></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Start being a <a class="el" href="classTFTP.html" title="A TFTP server.">TFTP</a> server. </p>
<p>This function does not return.</p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramdir">[in]</td><td class="paramname">port</td><td>The port number on which to listen. The default is 69. </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>N/A. </dd></dl>

</div>
</div>
<hr/>The documentation for this class was generated from the following files:<ul>
<li><a class="el" href="TFTP_8h_source.html">TFTP.h</a></li>
<li>TFTP.cpp</li>
</ul>
</div><!-- contents -->
<!-- start footer part -->
<hr class="footer"/><address class="footer"><small>
Generated by &#160;<a href="http://www.doxygen.org/index.html">
<img class="footer" src="doxygen.png" alt="doxygen"/>
</a> 1.8.15
</small></address>
</body>
</html>
